You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

78 lines
3.1 KiB

3 years ago
  1. #!/usr/bin/env zsh
  2. # -------------------------------------------------------------------------------------------------
  3. # Copyright (c) 2010-2015 zsh-syntax-highlighting contributors
  4. # All rights reserved.
  5. #
  6. # Redistribution and use in source and binary forms, with or without modification, are permitted
  7. # provided that the following conditions are met:
  8. #
  9. # * Redistributions of source code must retain the above copyright notice, this list of conditions
  10. # and the following disclaimer.
  11. # * Redistributions in binary form must reproduce the above copyright notice, this list of
  12. # conditions and the following disclaimer in the documentation and/or other materials provided
  13. # with the distribution.
  14. # * Neither the name of the zsh-syntax-highlighting contributors nor the names of its contributors
  15. # may be used to endorse or promote products derived from this software without specific prior
  16. # written permission.
  17. #
  18. # THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
  19. # IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
  20. # FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
  21. # CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  22. # DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  23. # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
  24. # IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
  25. # OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  26. # -------------------------------------------------------------------------------------------------
  27. # -*- mode: zsh; sh-indentation: 2; indent-tabs-mode: nil; sh-basic-offset: 2; -*-
  28. # vim: ft=zsh sw=2 ts=2 et
  29. # -------------------------------------------------------------------------------------------------
  30. # Load the main script.
  31. typeset -a region_highlight
  32. . ${0:h:h}/zsh-syntax-highlighting.zsh
  33. # Activate the highlighter.
  34. ZSH_HIGHLIGHT_HIGHLIGHTERS=(main)
  35. source_file=0.7.1:highlighters/$1/$1-highlighter.zsh
  36. # Runs a highlighting test
  37. # $1: data file
  38. run_test_internal() {
  39. setopt interactivecomments
  40. local -a highlight_zone
  41. local tests_tempdir="$1"; shift
  42. local srcdir="$PWD"
  43. builtin cd -q -- "$tests_tempdir" || { echo >&2 "Bail out! cd failed: $?"; return 1 }
  44. # Load the data and prepare checking it.
  45. PREBUFFER=
  46. BUFFER=$(cd -- "$srcdir" && git cat-file blob $source_file)
  47. expected_region_highlight=()
  48. zmodload zsh/zprof
  49. zprof -c
  50. # Set $? for _zsh_highlight
  51. true && _zsh_highlight
  52. zprof
  53. }
  54. run_test() {
  55. # Do not combine the declaration and initialization: «local x="$(false)"» does not set $?.
  56. local __tests_tempdir
  57. __tests_tempdir="$(mktemp -d)" && [[ -d $__tests_tempdir ]] || {
  58. echo >&2 "Bail out! mktemp failed"; return 1
  59. }
  60. typeset -r __tests_tempdir # don't allow tests to override the variable that we will 'rm -rf' later on
  61. {
  62. (run_test_internal "$__tests_tempdir" "$@")
  63. } always {
  64. rm -rf -- "$__tests_tempdir"
  65. }
  66. }
  67. run_test